SystemOrganization addCategory: #Estanciero!

Object subclass: #Banco
	instanceVariableNames: 'propiedades nombre'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Estanciero'!

!Banco class methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:11'!
instance
Instance ifNil: [ Instance := self new ].
^Instance.! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/6/2012 17:48'!
cayo: unJugador en: unaPropiedad

(unJugador puedeComprar: unaPropiedad) ifTrue: [unJugador compra: unaPropiedad].
! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/16/2012 17:50'!
cobra: unMonto
! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 21:04'!
initialize 
propiedades := Set new.
nombre := 'Banco'.! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 21:04'!
nombre
^nombre.! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/17/2012 15:04'!
paga: unMonto! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/16/2012 17:48'!
pagaA: unJugador elMontoDe: unMonto 

unJugador cobra: unMonto.! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/17/2012 14:06'!
quitarPropiedad: unaPropiedad 

propiedades remove:  unaPropiedad.! !

Object subclass: #Casillero
	instanceVariableNames: 'duenio precioDeCompra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Casillero methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:30'!
cayo: unJugador! !

!Casillero methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 02:54'!
paso: unJugador 
! !

!Casillero methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 15:02'!
sosEmpresa 
^false.! !

Casillero subclass: #PremioGanadero
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!PremioGanadero methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:08'!
cayo: unJugador 
unJugador cobra: 2500.! !

Casillero subclass: #Prision
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Estanciero'!

!Prision class methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:12'!
instance
Instance ifNil: [ Instance := self new ].
^Instance.! !

Casillero subclass: #Propiedad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

Propiedad subclass: #Campo
	instanceVariableNames: 'provincia valorRentaFijo costoDeEstancia cantidadDeEstancias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 22:57'!
agregarEstancia
provincia agregarEstanciaEn: self.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 23:18'!
cantidadDeEstancias
^cantidadDeEstancias.
! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:33'!
costoDeEstancia 
^costoDeEstancia.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:35'!
costoDeEstancia: unMonto 
costoDeEstancia := unMonto.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 14:33'!
dueniosDePropiedadesAmigas
^(self provincia) duenios! !

!Campo methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 13:26'!
hayAlgunDuenioDistintoDe: unJugador
^(self provincia) duenios anySatisfy: [ :unElem | unElem ~= unJugador & unElem ~= Banco ]! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 23:17'!
initialize 
cantidadDeEstancias := 0! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 21:37'!
perteneceAProvincia: unaProvincia
provincia := unaProvincia.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 21:38'!
provincia
^provincia.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/25/2012 01:04'!
rentaPara: jugadorQueCayo

^((2 raisedTo: cantidadDeEstancias) * valorRentaFijo).! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 23:46'!
sumarEstancia 
cantidadDeEstancias := cantidadDeEstancias +1! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:40'!
valorDeRentaFijo 
^valorRentaFijo ! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:40'!
valorDeRentaFijo: unMonto 
valorRentaFijo := unMonto.! !

Propiedad subclass: #Empresa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Empresa methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 15:26'!
dueniosDePropiedadesAmigas
^Tablero instance dueniosEmpresas
! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/25/2012 01:05'!
rentaPara: jugadorQueCayo

|empresasAcumuladas valorDados|

empresasAcumuladas := duenio cantidadDeEmpresas.
valorDados := jugadorQueCayo tirarDados.

^(valorDados * 30000 * empresasAcumuladas).! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/16/2012 17:32'!
sosEmpresa
^true! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/6/2012 17:23'!
cayo: unJugador 

(duenio = unJugador) ifFalse: [duenio cayo: unJugador en: self].! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:24'!
duenio
^duenio.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:28'!
duenio: elDuenio
(duenio notNil) ifTrue: [duenio quitarPropiedad: self].
duenio := elDuenio.
duenio agregarPropiedad: self.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 17:11'!
hayAlgunDuenioDistintoDe: unJugador
^(self dueniosDePropiedadesAmigas ) anySatisfy: [ :unElem | unElem ~= unJugador & unElem ~= Banco instance]! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 17:11'!
leSirveParaElImperioDe: unJugador
^(self dueniosDePropiedadesAmigas ) allSatisfy: [ :unElem | unElem = unJugador | unElem = Banco instance ]! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 00:44'!
precioDeCompra
^precioDeCompra.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 00:43'!
precioDeCompra: unPrecio
precioDeCompra := unPrecio.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/25/2012 00:52'!
sosCompradaPor: unJugador

unJugador paga: precioDeCompra.
duenio quitarPropiedad: self.
self duenio: unJugador.
unJugador agregarPropiedad: self.! !

Casillero subclass: #Salida
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Salida methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 02:54'!
paso: unJugador 
unJugador cobra: 5000.! !

Object subclass: #Dados
	instanceVariableNames: 'doble valor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Dados methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:58'!
initialize 

|dado1 dado2|

dado1 := (Interval from: 1 to: 6)atRandom.
dado2 := (Interval from: 1 to: 6)atRandom.

(dado1 = dado2) ifFalse: [doble := false] ifTrue: [doble := true].

valor := dado1 + dado2.! !

!Dados methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:26'!
sosDoble

^doble.! !

!Dados methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:59'!
valor
^valor.! !

Object subclass: #EstrategiaGarca
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!EstrategiaGarca methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 13:02'!
compraria: unaPropiedad siendoElDuenio: unJugador 

^unaPropiedad hayAlgunDuenioDistintoDe: unJugador

! !

Object subclass: #EstrategiaImperialista
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!EstrategiaImperialista methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 17:08'!
compraria: unaPropiedad siendoElDuenio: unJugador
^unaPropiedad leSirveParaElImperioDe: unJugador
! !

Object subclass: #EstrategiaStandard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!EstrategiaStandard methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 11:59'!
compraria: unaPropiedad siendoElDuenio: unJugador
^true.! !

Object subclass: #Juego
	instanceVariableNames: 'jugadores tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Juego methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:22'!
queJuegue: unJugador 

|casillerosAMoverse|

casillerosAMoverse := tablero casillerosDesde: (unJugador casilleroDondeEsta) hasta: (unJugador tirarDados).

(unJugador sacoDoble) ifFalse: [unJugador estado pasoUnTurno: unJugador] 
ifTrue: [unJugador estado pasoUnTurnoConDoble: unJugador].

(unJugador estado sePuedeMover) ifFalse: [self queJuegueElQueSigue] 
ifTrue: [unJugador movetePor: casillerosAMoverse].

! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 02:09'!
queJuegueElQueSigue
| elQueSigue |
elQueSigue := self jugadores add: self jugadores removeFirst.
self queJuegue: elQueSigue.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:58'!
tablero
^tablero.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:58'!
tablero: unTablero
tablero := unTablero.! !

Object subclass: #Jugador
	instanceVariableNames: 'dinero propiedades casillero estrategia numero estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:25'!
agregarPropiedad: unaPropiedad 

propiedades add: unaPropiedad.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/16/2012 21:13'!
cantidadDeEmpresas

|cantEmpresas|

cantEmpresas := propiedades select: [:propiedad | propiedad sosEmpresa].

^(cantEmpresas size).! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:41'!
casilleroDondeEsta
^casillero.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:41'!
casilleroDondeEsta: unCasillero

casillero := unCasillero.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/25/2012 01:06'!
cayo: unJugador en: unaPropiedad 

|monto|

monto := (unaPropiedad rentaPara: unJugador).

unJugador pagaA: self elMontoDe: monto.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:31'!
cobra: unMonto
dinero := dinero + unMonto.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/25/2012 00:52'!
compra: unaPropiedad 

unaPropiedad sosCompradaPor: self.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 20:46'!
dinero
^dinero.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 20:51'!
dinero: monto
dinero := monto.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:17'!
estado

^estado.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:10'!
estasLibre 

estado := JugadorLibre new.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:11'!
estasPreso 

casillero := Prision instance.
estado := JugadorPreso new.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'palbo 10/6/2012 17:51'!
estrategia
^estrategia.
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:09'!
initialize 
propiedades := Set new.
estado := JugadorLibre new.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:53'!
movetePor: unosCasilleros

|ultimoCasillero|

(unosCasilleros notEmpty) whileTrue: [
	ultimoCasillero := unosCasilleros removeFirst.
	ultimoCasillero paso: self].

ultimoCasillero cayo: self.

self casilleroDondeEsta: ultimoCasillero.

! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:30'!
paga: unMonto
dinero := dinero - unMonto.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/16/2012 17:47'!
pagaA: unJugador elMontoDe: unMonto 

(unMonto > dinero) ifTrue: [self error: 'No tiene dinero suficiente.'].
self paga: unMonto.
unJugador cobra: unMonto.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/11/2012 01:24'!
propiedades
^propiedades.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 12:39'!
puedeComprar: unaPropiedad
^(self estrategia) compraria: unaPropiedad siendoElDuenio: self! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:03'!
sacoDoble

^(numero sosDoble).
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:01'!
tirarDados

numero := Dados new.
^(numero valor).! !

Object subclass: #JugadorLibre
	instanceVariableNames: 'primerDoble'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!JugadorLibre methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:46'!
initialize 

primerDoble := false.! !

!JugadorLibre methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:08'!
pasoUnTurno: unJugador 
! !

!JugadorLibre methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:09'!
pasoUnTurnoConDoble: unJugador 

(primerDoble) ifFalse: [primerDoble := true] ifTrue: [unJugador estasPreso].

! !

!JugadorLibre methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:21'!
sePuedeMover

^true.! !

Object subclass: #JugadorPreso
	instanceVariableNames: 'cantTurnos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!JugadorPreso methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:49'!
initialize 

cantTurnos := 0.! !

!JugadorPreso methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:07'!
pasoUnTurno: unJugador 

cantTurnos := cantTurnos + 1.

(cantTurnos = 3) ifTrue: [unJugador estasLibre].! !

!JugadorPreso methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:07'!
pasoUnTurnoConDoble: unJugador 

unJugador estasLibre.! !

!JugadorPreso methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:21'!
sePuedeMover

^false.! !

Object subclass: #Provincia
	instanceVariableNames: 'campos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 21:37'!
agregarCampo: unCampo
campos add: unCampo.
unCampo perteneceAProvincia: self.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:33'!
agregarEstanciaEn: unCampo

|cantidadMinimaDeEstancias|

((self duenios) size = 1) ifFalse: [self error: 'No cumple con monopolio'].

cantidadMinimaDeEstancias := ((self estancias) asSortedCollection: [:anterior :siguiente | anterior < siguiente]) first.
(cantidadMinimaDeEstancias = unCampo cantidadDeEstancias) ifFalse: [self error: 'No cumple con construccin pareja'].

(unCampo duenio) paga: (unCampo costoDeEstancia).

unCampo sumarEstancia.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/11/2012 01:46'!
campos
^campos.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 23:01'!
duenios
^(campos collect: [:campo|campo duenio]).! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 23:36'!
estancias
^(campos collect: [:campo|campo cantidadDeEstancias]).! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/11/2012 01:43'!
initialize 
campos := Set new.! !

Object subclass: #Tablero
	instanceVariableNames: 'casilleros'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Tablero methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 15:11'!
casilleros
^casilleros! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:54'!
casillerosDesde: casilleroInicial hasta: unNumero
| misCasilleros recorrido |
misCasilleros := self casilleros copyAfter: casilleroInicial.
recorrido := OrderedCollection new.
[ recorrido size >= unNumero ] whileFalse: [
misCasilleros ifEmpty: [
misCasilleros addAll: self casilleros.
].
recorrido add: misCasilleros removeFirst. ].
^recorrido.! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 15:13'!
casillerosEmpresa
^ self casilleros select: [ :unElem | unElem sosEmpresa ]! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 15:27'!
dueniosEmpresas
^( self casillerosEmpresa collect: [:unElem | unElem duenio]).! !
